3 # Copyright (c) 2005 Junio C Hamano
5 # Fetch one or more remote refs and merge it/them into the current HEAD.
7 USAGE='[-n | --no-summary] [--no-commit] [-s strategy]... [<fetch-options>] <repo> <head>...'
8 LONG_USAGE='Fetch one or more remote refs and merge it/them into the current HEAD.'
10 set_reflog_action "pull $*"
13 test -z "$(git ls-files -u)" ||
14 die "You are in a middle of conflicted merge."
16 strategy_args= no_summary= no_commit= squash=
17 while case "$#,$1" in 0) break ;; *,-*) ;; *) break ;; esac
20 -n|--n|--no|--no-|--no-s|--no-su|--no-sum|--no-summ|\
21 --no-summa|--no-summar|--no-summary)
23 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
24 no_commit=--no-commit ;;
25 --sq|--squ|--squa|--squas|--squash)
27 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
28 --strateg=*|--strategy=*|\
29 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
32 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
39 strategy_args="${strategy_args}-s $strategy "
41 -h|--h|--he|--hel|--help)
45 # Pass thru anything that is meant for fetch.
52 orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
53 git-fetch --update-head-ok "$@" || exit 1
55 curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
56 if test "$curr_head" != "$orig_head"
58 # The fetch involved updating the current branch.
60 # The working tree and the index file is still based on the
61 # $orig_head commit, but we are merging into $curr_head.
62 # First update the working tree to match $curr_head.
64 echo >&2 "Warning: fetch updated the current branch head."
65 echo >&2 "Warning: fast forwarding your working tree from"
66 echo >&2 "Warning: commit $orig_head."
67 git-update-index --refresh 2>/dev/null
68 git-read-tree -u -m "$orig_head" "$curr_head" ||
69 die 'Cannot fast-forward your working tree.
70 After making sure that you saved anything precious from
71 $ git diff '$orig_head'
78 merge_head=$(sed -e '/ not-for-merge /d' \
79 -e 's/ .*//' "$GIT_DIR"/FETCH_HEAD | \
84 curr_branch=$(git-symbolic-ref HEAD | \
85 sed -e 's|^refs/heads/||')
86 echo >&2 "Warning: No merge candidate found because value of config option
87 \"branch.${curr_branch}.merge\" does not match any remote branch fetched."
88 echo >&2 "No changes."
92 if test -z "$orig_head"
94 echo >&2 "Cannot merge multiple branches into empty head"
100 if test -z "$orig_head"
102 git-update-ref -m "initial pull" HEAD $merge_head "" &&
103 git-read-tree --reset -u HEAD || exit 1
107 merge_name=$(git-fmt-merge-msg <"$GIT_DIR/FETCH_HEAD") || exit
108 exec git-merge $no_summary $no_commit $squash $strategy_args \
109 "$merge_name" HEAD $merge_head